// Geom2D.java


public class Geom2D
{
	static final double degrees_per_radian = 180.0/Math.PI;
	
	public static double dot(Point a, Point b)
	{
		return a.x*b.x+a.y*b.y;
	}

	public static double cross(Point a, Point b)
	{
		return a.x*b.y - b.x*a.y;
	}

	public static double angle(Point a, Point b, Point c)
	{
		Point ra = new Point(a.x-b.x,a.y-b.y);
		Point rc = new Point(c.x-b.x,c.y-b.y);
		ra.setSize(1.0);
		rc.setSize(1.0);
		return Math.atan2(cross(rc,ra),dot(rc,ra))*degrees_per_radian;
	}

	public static Point getPosition(Line line, Point pt)
	{
		Point p = new Point(pt.x-line.pa.x,pt.y-line.pa.y);
		Point r = new Point(line.pb.x-line.pa.x,line.pb.y-line.pa.y);
		double x = dot(p,r);
		double y = cross(p,r);
		double sq = r.x*r.x+r.y*r.y;
		return new Point(x/sq,y/sq);
	}
}