// Point.java
// Definition of class Point (version 3)
import java.awt.Graphics; 

/**
*  <b>Point</b> describes a two-dimensional point.
*/

public class Point
{
	static double scale = 72;
	static double yoffset = 120;
	public double x, y; // coordinates of the Point

	public Point() { }

	// Constructor
	public Point( double a, double b )
	{
		x = a;
		y = b;
	}


	// Set x and y coordinates of Point
	public void setPoint( double a, double b )
	{
		x = a;
		y = b;
	}

	// get x pixel value
	public int getX() { return (int)(x*scale); }

	// get y pixel value
	public int getY() { return (int)(yoffset - y*scale); }

	public double getSize()
	{
		return Math.sqrt(x*x+y*y);
	}
	
	public double hypot()
	{
		double a, b, vmin, vmax;
		a = Math.abs(x);
		b = Math.abs(y);
		if (a>b) {
			vmax=a;
			vmin=b;
		}
		else {
			vmax=b;
			vmin=a;
		}
		if (vmin==0.0) return vmax;
		vmin /= vmax;
		return vmax*Math.sqrt(1.0+vmin*vmin);
	}

	public void setSize(double v)
	{
		double vnorm = getSize();
		if (vnorm==0.0) return;
		v /= vnorm;
		x *= v;
		y *= v;
	}
	
	// offset (translate) point by the amount (tx, ty)
	public void offset(double tx, double ty)
	{
		x += tx;
		y += ty;
	}

	public void draw(Graphics g)
	{
		g.fillOval(getX()-4,getY()-4,9,9);
	}   

   // convert the point into a String representation
   public String toString()
      { return " (" + x + ", " + y + ")"; }
}
