// Line.java
// Definition of class Line (version 1)
import java.awt.Graphics; 

/**
*  <b>Line</b> describes a two-dimensional line.
*
*     The line is defined by parametric equations
*
*          x(u) = p.x + kx * u;
*          y(u) = p.y + ky * u;
*/


public class Line {
	public Point pa = new Point();
	public Point pb = new Point();


	public Line(Point a, Point b) { this(a.x,a.y,b.x,b.y); }
	public Line(double x1, double y1, double x2, double y2)
	{
		pa.x = x1;
		pa.y = y1;
		pb.x = x2;
		pb.y = y2;
	}

	public void setLine(double x1, double y1, double x2, double y2)
	{
		pa.setPoint(x1,y1);
		pb.setPoint(x2,y2);
	}

	public void negate()
	{
		Point tmp = pa;
		pa = pb;
		pb = tmp;
	}

	public Point getDirection()
	{
		return new Point(pb.x-pa.x,pb.y-pa.y);
	}

	public void draw(Graphics g)
	{
		g.drawLine(pa.getX(),pa.getY(),pb.getX(),pb.getY());
	}
}	