// Circle.java
// Definition of class Circle
import java.awt.Graphics; 

public class Circle extends Point {  // inherits from Point
   protected double radius = 1.2;

   // No-argument constructor
   public Circle()
   {
      // implicit call to superclass constructor occurs here
	  System.out.println("Default Circle constructor called: " + this);
   }

   // Constructor
   public Circle( double a, double b, double r )
   {
      super( a, b );  // call to superclass constructor
      setRadius( r );
	  System.out.println("Circle constructor:" + this);
   }

   // Set radius of Circle
   public void setRadius( double r ) 
      { radius = ( r >= 0.0 ? r : 0.0 ); }

   // Get radius of Circle
   public double getRadius() { return radius; }

   // Calculate area of Circle
   public double area() { return Math.PI * radius * radius; }

   public void draw(Graphics g)
   {
	   int nx = (int) (x*SCALE);
	   int ny = (int) (y*SCALE);
	   int r = (int) (radius*SCALE);
	   int w = 2*r+1;
	   g.drawOval(nx-r,ny-r,w,w);
   }   
   
   // convert the Circle to a String
   public String toString()
   {
      return " Center =" + super.toString() + "; Radius = " + radius;
   }
}
