// InheritanceTest.java
// Demonstrating the "is a" relationship
import java.text.DecimalFormat;
import javax.swing.JOptionPane;

public class InheritanceTest {
   public static void main( String args[] )
   {
      Point pointRef, p; 
      Circle circleRef, c;
      String output;

      p = new Point( .30, .50 );
      c = new Circle( 1.20, .89, 0.15 );

      output = "Point p: " + p.toString() +
               "\nCircle c: " + c.toString();
   
      // use the "is a" relationship to refer to a Circle
      // with a Point reference
      pointRef = c;   // assign Circle to pointRef

      output += "\n\nCircle c (via pointRef): " +
                pointRef.toString();

      // Use downcasting (casting a superclass reference to a
      // subclass data type) to assign pointRef to circleRef
      circleRef = (Circle) pointRef;

      output += "\n\nCircle c (via circleRef): " +
                circleRef.toString();

      DecimalFormat precision4 = new DecimalFormat( "0.0000" );
      output += "\nArea of c (via circleRef): " +
                precision4.format( circleRef.area() );

      // Attempt to refer to Point object
      // with Circle reference
	circleRef = (Circle) p;
	System.out.println("area = " + circleRef.area() );
      if ( p instanceof Circle ) {
         circleRef = (Circle) p;  
         output += "\n\ncast successful";
      }
      else
         output += "\n\np does not refer to a Circle";

      JOptionPane.showMessageDialog( null, output,
         "Demonstrating the \"is a\" relationship",
         JOptionPane.INFORMATION_MESSAGE );

      System.exit( 0 );
   }
}
