// Point.java
// Definition of class Point (simple)
import java.awt.Graphics; 

/**
*  <b>Point</b> describes a two-dimensional point.
*/

public class Point
{
	static final double SCALE = 100;
	public double x, y; // coordinates of the Point

	// No-argument constructor
	public Point()
	{
		System.out.println("Point (no-argument constructor called: " + this);
	}


	// Constructor
	public Point( double a, double b )
	{
		setPoint( a, b );
		System.out.println("Point constructor:" + this);
	}

	protected void finalize()
	{
		System.out.println("Point finalizer:"+this);
	}


	// Set x and y coordinates of Point
	public void setPoint( double a, double b )
	{
		x = a;
		y = b;
	}

	public void draw(Graphics g)
	{
		int nx = (int) (x*SCALE);
		int ny = (int) (y*SCALE);
		g.fillOval(nx-5,ny-5,11,11);
	}   

   // convert the point into a String representation
   public String toString()
      { return " (" + x + ", " + y + ")"; }
}
