// Line.java
// Definition of class Line (version 1)
import java.awt.Graphics; 

/**
*  <b>Line</b> describes a two-dimensional line.
*
*     The line is defined by parametric equations
*
*          x(u) = pa.x * (1-u) + pb.x * u;
*          y(u) = pa.y * (1-u) + pb.y * u;
*/


public class Line {
	public Point pa = new Point();
	public Point pb = new Point();

	public Line() { setLine(0,0,0,0); }

	public Line(Point a, Point b) { setLine(a.x,a.y,b.x,b.y); }

	public void setLine(double x1, double y1, double x2, double y2)
	{
		pa.setPoint(x1,y1);
		pb.setPoint(x2,y2);
	}

	public Point getPoint(double u)
	{
		double up = 1.0-u;
		double x = pa.x * up + pb.x * u;
		double y = pa.y * up + pb.y * u;
		return new Point(x,y);
	}

	public void draw(Graphics g)
	{
		g.drawLine(pa.nX(),pa.nY(),pb.nX(),pb.nY());
	}
}
