// Point.java
// Definition of class Point (version 2)
import java.awt.Graphics; 

/**
*  <b>Point</b> describes a two-dimensional point.
*/

public class Point
{
	static final double SCALE = 100;
	public double x, y; // coordinates of the Point

	// No-argument constructor
	public Point() { setPoint( 0, 0 ); }


	// Constructor
	public Point( double a, double b ) { setPoint( a, b ); }


	// Set x and y coordinates of Point
	public void setPoint( double a, double b )
	{
		x = a;
		y = b;
	}

	// get x pixel value
	public int nX() { return (int)(x*SCALE); }

	// get y pixel value
	public int nY() { return (int)(y*SCALE); }

	//  set X coordinate
	public Point setX(double a)
	{
		x = a;
		return this;
	}

	// set Y coordinate
	public Point setY(double b)
	{
		y = b;
		return this;
	}

	// offset (translate) point by the amount (tx, ty)
	public void offset(double tx, double ty)
	{
		x += tx;
		y += ty;
	}

	public void draw(Graphics g)
	{
		int nx = nX();
		int ny = nY();
		g.fillOval(nx-5,ny-5,11,11);
	}   

   // convert the point into a String representation
   public String toString()
      { return " (" + x + ", " + y + ")"; }
}
