// Point.java
// Definition of class Point (version 1)
import java.awt.Graphics; 

/**
*  <b>Point</b> describes a two-dimensional point.
*/

public class Point
{
	static final double SCALE = 100;
	private double x, y; // coordinates of the Point

	// No-argument constructor
	public Point() { setPoint( 0, 0 ); }


	// Constructor
	public Point( double a, double b ) { setPoint( a, b ); }


	// Set x and y coordinates of Point
	public void setPoint( double a, double b )
	{
		x = a;
		y = b;
	}

	// get x coordinate
	public double getX() { return x; }  

	// get y coordinate
	public double getY() { return y; }

	public void draw(Graphics g)
	{
		int nx = (int) (x*SCALE);
		int ny = (int) (y*SCALE);
		g.fillOval(nx-5,ny-5,11,11);
	}   

   // convert the point into a String representation
   public String toString()
      { return " (" + x + ", " + y + ")"; }
}
