// DrawPanel.java
// Draws two crossing lines on a panel.
import java.awt.Graphics; 
import javax.swing.*;

public class DrawPanel extends JPanel
{
	public static void main( String args[] )
	{
		// create a panel that contains our drawing
		DrawPanel panel = new DrawPanel();

		// create a new frame to hold the panel
		JFrame application = new JFrame("DrawPanel");

		// set the frame to exit when it is closed
		application.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );

		application.add( panel ); // add the panel to the frame      
		application.setSize( 250, 250 ); // set the size of the frame
		application.setVisible( true ); // make the frame visible

		int width = application.getWidth();
		int height = application.getHeight();
		System.out.printf("application width %d height %d\n",width,height);
	} 

	   // draws an X from the corners of the panel
	   public void paintComponent( Graphics g )
	   {
	      // call paintComponent to ensure the panel displays correctly
	      super.paintComponent( g );
      
	      int width = getWidth(); // total width   
	      int height = getHeight(); // total height
	      System.out.printf("width %d height %d\n",width,height);

	      // draw a line from the upper-left to the lower-right
	      g.drawLine( 0, 0, width, height );
      
	      // draw a line from the lower-left to the upper-right
	      g.drawLine( 0, height, width, 0 );
	   } 
} 
